var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { Subject } from './subject';

/**
 * BehaviorSubject extends Subject. As Subject is a stream of values, BehaviorSubject
 * is also a stream, but a little bit different. The difference is that BehaviorSubject
 * remembers the last value that's been sent to it, and it sends this value to
 * new subscribers. Take a look at example.
 *
 * @example
 * import { BehaviorSubject } from 'rxstream';
 *
 * let stream$ = new BehaviorSubject();
 * stream$.next(1);
 * stream$.next(2);
 *
 * stream$.subscribe(value => console.log(value));
 * stream$.next(3);
 * stream$.next(4);
 *
 * // Output is going ot be: 2,3,4
 *
 * @class BehaviorSubject<T>
 */
export var BehaviorSubject = function (_Subject) {
  _inherits(BehaviorSubject, _Subject);

  function BehaviorSubject() {
    _classCallCheck(this, BehaviorSubject);

    var _this = _possibleConstructorReturn(this, (BehaviorSubject.__proto__ || Object.getPrototypeOf(BehaviorSubject)).call(this));

    _this._lastCallArgs = null;
    return _this;
  }

  /**
   * Send value to the stream
   * @param {any} data Any value
   */


  _createClass(BehaviorSubject, [{
    key: 'next',
    value: function next(data) {
      this._lastCallArgs = arguments;
      _get(BehaviorSubject.prototype.__proto__ || Object.getPrototypeOf(BehaviorSubject.prototype), 'next', this).apply(this, arguments);
    }
  }, {
    key: 'subscribe',


    /**
     * Subscribe to the stream
     * @param {function} callback
     * @returns {Subscription}
     */
    value: function subscribe(callback) {
      if (this._lastCallArgs) {
        callback.apply(this, this._lastCallArgs);
      }

      _get(BehaviorSubject.prototype.__proto__ || Object.getPrototypeOf(BehaviorSubject.prototype), 'subscribe', this).apply(this, arguments);
    }
  }]);

  return BehaviorSubject;
}(Subject);