var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import { Subject } from './subject';

/**
 * ReplaySubject extends Subject. As Subject is a stream of values, ReplaySubject
 * is also a stream, but a little bit different. The difference is that ReplaySubject
 * remembers all values that's been sent to it, and it sends all these values to
 * new subscribers. Take a look at example.
 *
 * @example
 * import { ReplaySubject } from 'rxstream';
 *
 * let stream$ = new ReplaySubject();
 * stream$.next(1);
 * stream$.next(2);
 *
 * stream$.subscribe(value => console.log(value));
 * stream$.next(3);
 * stream$.next(4);
 *
 * // Output is going ot be: 1,2,3,4
 *
 * @class ReplaySubject<T>
 */
export var ReplaySubject = function (_Subject) {
  _inherits(ReplaySubject, _Subject);

  function ReplaySubject() {
    _classCallCheck(this, ReplaySubject);

    var _this = _possibleConstructorReturn(this, (ReplaySubject.__proto__ || Object.getPrototypeOf(ReplaySubject)).call(this));

    _this.calls = [];
    return _this;
  }

  /**
   * Send value to the stream
   * @param {any} data Any value
   */


  _createClass(ReplaySubject, [{
    key: 'next',
    value: function next(data) {
      this.calls.push(arguments);
      _get(ReplaySubject.prototype.__proto__ || Object.getPrototypeOf(ReplaySubject.prototype), 'next', this).apply(this, arguments);
    }
  }, {
    key: 'subscribe',


    /**
     * Subscribe to the stream
     * @param {function} callback
     * @returns {Subscription}
     */
    value: function subscribe(callback) {
      var _this2 = this;

      if (this.calls.length) {
        this.calls.forEach(function (callArgs) {
          callback.apply(_this2, callArgs);
        });
      }

      _get(ReplaySubject.prototype.__proto__ || Object.getPrototypeOf(ReplaySubject.prototype), 'subscribe', this).apply(this, arguments);
    }
  }]);

  return ReplaySubject;
}(Subject);