var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import Subscription from '../classes/subscription';

/**
 * Subject is a stream of values, that were pushed into it.
 *
 * @example
 * import { Subject } from 'rxstream';
 *
 * let stream$ = new Subject();
 * stream$.subscribe(value => console.log(value));
 * stream$.next(1); // 1
 * stream$.next(2); // 2
 *
 * @class Subject<T>
 */

var Subject = function () {
  function Subject() {
    _classCallCheck(this, Subject);

    /**
     * @type {Array}
     * @private
     */
    this._subscriptionList = [];
  }

  _createClass(Subject, [{
    key: 'subscriptionList',
    value: function subscriptionList(_subscriptionList) {
      if (_subscriptionList instanceof Array) {
        this._subscriptionList = _subscriptionList;
      }

      return this._subscriptionList;
    }

    /**
     * Send value to the stream
     * @param {any} data Any value
     */

  }, {
    key: 'next',
    value: function next(data) {
      this.subscriptionList().forEach(function (subscription) {
        subscription._execute(data);
      });
    }

    /**
     * Subscribe to the stream
     * @param {function} callback
     * @returns {Subscription}
     */

  }, {
    key: 'subscribe',
    value: function subscribe(callback) {
      var subscription = new Subscription(this, callback);
      this.subscriptionList().push(subscription);

      return subscription;
    }
  }, {
    key: 'unsubscribe',


    /**
     * Unsubscribe from the stream
     * @param {Subscription} subscription
     */
    value: function unsubscribe(subscription) {
      if (!(subscription instanceof Subscription)) {
        return;
      }

      this.subscriptionList(this.subscriptionList().filter(function (_subscription) {
        return _subscription !== subscription;
      }));
    }
  }]);

  return Subject;
}();

export { Subject };